﻿using Central.Control.WebApi.DbEntity;
using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Linq;
using System.Web;

namespace Central.Control.WebApi.EFDbContext
{
    /// <summary>
    /// 
    /// </summary>
    public class CentralControlContext : DbContext, IDbContext
    {
        /// <summary>
        /// 
        /// </summary>
        public CentralControlContext() : base("name=CentralControlSystem")
        {
            
        }

        /// <summary>
        /// 设备表
        /// </summary>
        public DbSet<SYS_Device> SYS_DEVICE { get; set; }

        /// <summary>
        /// YW_PRODUCT商品表
        /// </summary>
        public DbSet<YW_Product> YW_PRODUCT { get; set; }

        /// <summary>
        /// YW_ORDER订单表
        /// </summary>
        public DbSet<YW_Order> YW_ORDER { get; set; }

        /// <summary>
        /// YW_ORDERDETAILS商品订单详细表
        /// </summary>
        public DbSet<YW_OrderDetails> YW_ORDERDETAILS { get; set; }

        /// <summary>
        /// SYS_LoginSession系统登录信息
        /// </summary>
        public DbSet<SYS_LoginSession> SYS_LoginSession { get; set; }

        /// <summary>
        /// YW_PayCall支付回写表
        /// </summary>
        public DbSet<YW_PayCall> YW_PayCall { get; set; }

        /// <summary>
        /// YW_OrderProcess订单制作过程表
        /// </summary>
        public DbSet<YW_OrderProcess> YW_OrderProcess { get; set; }

        /// <summary>
        /// 删除
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="id"></param>
        public void Delete<T>(string id) where T: class
        {
            var entity = this.Set<T>().Find(id);
            this.Set<T>().Remove(entity);
            this.SaveChanges();
        }
    }
}